library(ggplot2)
library(tidyr)
library(ncdf4)
#library(trend)
library(loadeR)
library(transformeR)
library(visualizeR)
library(RColorBrewer)
library(metR)

rm(list=ls()) ; gc()

#Working directory
dir <- "/esarchive/scratch/molmo/CLIMCAT_MJ/CMIP6/"
OUTPUTS <- "/esarchive/scratch/molmo/CLIMCAT_MJ/OUTPUTS/"
setwd(dir)

invariable <- loadGridData(dataset = "/esarchive/scratch/molmo/mask_1_Med_bil.nc",
                           var="precip") %>% binaryGrid(condition = "GE",threshold=0)
scenario <- c("ssp126","ssp245","ssp585")

# for(sc in 1:length(scenario)){
#   
#   #-------Annual indices---------#
#   #Useful information
#   indices <- c("wsdi","csdi","tr",
#                "r20mm","prcptot","cdd","cwd")
#   files <- intersect(list.files(pattern="2100.nc",recursive = T),list.files(pattern="yr",recursive = T))
#   files <- intersect(files,list.files(pattern=scenario[sc],recursive=T))
#   
#   ssn <- "Annual"
#   seasons <- list(c(1:12))
#   Model <- NA
#   
#   series.indices <- list()
#   
#   for(i in 1:length(indices)){
#     print(indices[i])
#     files_subset <- intersect(files,list.files(pattern=indices[i],recursive=T))
#     series.indices[[i]] <- list()
#     
#     for(m in 1:length(files_subset)){
#       print(files_subset[m])
#       
#       series.indices[[i]][[m]] <- list()
#       
#       for(s in 1:length(seasons)){
#         di <- dataInventory(files_subset[m])
#         
#         ini <- nchar(names(di))                            
#         out <- nchar("_historical-ssp585_r1i1p1f1_1950-2100.nc") 
#         Model[m] <- substr(files_subset[m],start=ini+32,stop=nchar(files_subset[m])-out)
#         
#         data <- loadGridData(files_subset[m],var=names(di),years=1950:2100)
#         
#         #Interpolate into a common grid and mask ocean
#         data <- interpGrid(data,new.coordinates = getGrid(invariable),method = "nearest")
#         # for(y in 1:dim(data$Data)[1]){
#         #   data$Data[y,,] <- data$Data[y,,]*invariable$Data[1,,]
#         # }
#         
#         #Estimating anomalies wrt 1981-2010 reference period
#         data <- scaleGrid(data,base = subsetGrid(data,years=1981:2010),type = "center")
#         data <- climatology(subsetYears(data,seq(2071,getYearsAsINDEX(data)[length(getYearsAsINDEX(data))])))
#         
#         #Serie regional
#         # EuroMediterranean <- aggregateGrid(data,aggr.spatial = list(FUN="mean",na.rm=T))
#         # Catalonia <- aggregateGrid(subsetGrid(data,latLim = c(40,43),lonLim = c(0,4)),aggr.spatial = list(FUN="mean",na.rm=T))
#         
#         Map <- data.frame(Value=c(data$Data),
#                           Season=ssn[s],
#                           Index=indices[i],
#                           Model=Model[m],
#                           Longitude=rep(data$xyCoords$x,each=length(data$xyCoords$y)),
#                           Latitude=rep(data$xyCoords$y,length(data$xyCoords$x)))
#         
#         # if(indices[i]%in%c("cdd")){paleta=rev(brewer.pal(11,"BrBG")); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # if(indices[i]%in%c("cwd","r20mm")){paleta=c(brewer.pal(11,"BrBG")); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # if(indices[i]%in%c("prcptot")){paleta=brewer.pal(11,"BrBG"); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # if(indices[i]%in%c("wsdi","tr")){paleta=rev(brewer.pal(11,"RdYlBu")); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # if(indices[i]%in%c("csdi")){paleta=brewer.pal(11,"RdYlBu"); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # 
#         # png(filename = paste(OUTPUTS,"DeltaChange_",ssn[s],"_",indices[i],"_",Model[m],"_Historical+",scenario[sc],".png",sep=""),res=600,width=3000,height=2000)
#         # print(ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + geom_contour_fill(bins=20)  +
#         #         scale_fill_gradientn(name=paste(di[[names(di)]][["Units"]]),colours=paleta,limits=range,na.value = "white")+
#         #         coord_quickmap(xlim=c(min(Map$Longitude),max(Map$Longitude)),
#         #                        ylim=c(min(Map$Latitude),max(Map$Latitude)),expand=F)+ borders(colour="black") +
#         #         theme_bw() + ggtitle(paste(ssn[s],indices[i],Model[m],"2071-2100",sep=" ")))#+geom_text(data=subset(datita,Significance<=0.05),aes(label="*",fontface="bold")))
#         # dev.off()
#         
#         series.indices[[i]][[m]][[s]] <- Map
#         gc()
#         
#       }
#     }
#   }
#   save(series.indices,file=paste("map.nomask.indices.yr.CMIP6.",scenario[sc],".Rdata",sep=""))
#   
#   #--------Seasonal indices--------------------#
#   files <- intersect(list.files(pattern="210012.nc",recursive = T),list.files(pattern="",recursive = T))
#   files <- intersect(files,list.files(pattern=scenario[sc],recursive=T))
#   
#   seasons <- list(c(12,1,2),c(3,4,5),c(6,7,8),c(9,10,11)) #DJF #MAM #JJA #SON #ANNUAL
#   ssn <- c("Winter","Spring","Summer","Autumn")#,"Annual")
#   indices <- c("txx","txn","tnx","tnn","tx90p","tx10p","tn90p","tn10p",
#                "rx5day","rx1day")
#   Model <- NA
#   
#   series.indices <- list()
#   
#   for(i in 1:length(indices)){
#     print(indices[i])
#     files_subset <- intersect(files,list.files(pattern=indices[i],recursive = T))
#     
#     series.indices[[i]] <- list()
#     
#     for(m in 1:length(files_subset)){
#       print(files_subset[m])
#       
#       series.indices[[i]][[m]] <- list()
#       
#       for(s in 1:length(seasons)){
#         di <- dataInventory(files_subset[m])
#         
#         ini <- nchar(names(di))                            
#         out <- nchar("_historical-ssp585_r1i1p1f1_195001-210012.nc") 
#         Model[m] <- substr(files_subset[m],start=ini+33,stop=nchar(files_subset[m])-out)
#         
#         data <- loadGridData(files_subset[m],var=names(di),years=1950:2100)
#         
#         #Interpolate into a common grid and mask ocean
#         data <- interpGrid(data,new.coordinates = getGrid(invariable),method = "nearest")
#         # for(y in 1:dim(data$Data)[1]){
#         #   data$Data[y,,] <- data$Data[y,,]*invariable$Data[1,,]
#         # }
#         
#         #Estimating anomalies wrt 1981-2010 reference period
#         data <- scaleGrid(data,base = subsetGrid(data,years=1981:2010),type = "center",time.frame = "monthly")
#         
#         data <- aggregateGrid(data,aggr.s = list(FUN=list("mean",na.rm=T),season=seasons[[s]]))
#         
#         data <- climatology(subsetYears(data,seq(2071,getYearsAsINDEX(data)[length(getYearsAsINDEX(data))])))
#         
#         #Serie regional
#         # EuroMediterranean <- aggregateGrid(data,aggr.spatial = list(FUN="mean",na.rm=T))
#         # Catalonia <- aggregateGrid(subsetGrid(data,latLim = c(40,43),lonLim = c(0,4)),aggr.spatial = list(FUN="mean",na.rm=T))
#         
#         Map <- data.frame(Value=c(data$Data),
#                           Season=ssn[s],
#                           Index=indices[i],
#                           Model=Model[m],
#                           Longitude=rep(data$xyCoords$x,each=length(data$xyCoords$y)),
#                           Latitude=rep(data$xyCoords$y,length(data$xyCoords$x)))
#         
#         # if(di[[names(di)]][["Units"]]%in%c("mm")){paleta=brewer.pal(11,"BrBG"); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # if(di[[names(di)]][["Units"]]%in%c("degrees_C","days","%")){paleta=rev(brewer.pal(11,"RdBu")); range=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T))))}
#         # 
#         # png(filename = paste(OUTPUTS,"DeltaChange_",ssn[s],"_",indices[i],"_",Model[m],"_Historical+",scenario[sc],".png",sep=""),res=600,width=3000,height=2000)
#         # print(ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + geom_contour_fill(bins=20)  +
#         #         scale_fill_gradientn(name=paste(di[[names(di)]][["Units"]]),colours=paleta,limits=range,na.value = "white")+
#         #         coord_quickmap(xlim=c(min(Map$Longitude),max(Map$Longitude)),
#         #                        ylim=c(min(Map$Latitude),max(Map$Latitude)),expand=F)+ borders(colour="black") +
#         #         theme_bw() + ggtitle(paste(ssn[s],indices[i],Model[m],"2071-2100",sep=" ")))#+geom_text(data=subset(datita,Significance<=0.05),aes(label="*",fontface="bold")))
#         # dev.off()
#         
#         series.indices[[i]][[m]][[s]] <- Map
#         gc()
#         
#       }
#     }
#   }
#   save(series.indices,file=paste("map.nomask.indices.mon.CMIP6.",scenario[sc],".Rdata",sep=""))
# }



#---Ensembles---#
invariable.data <- data.frame(Longitude=rep(invariable$xyCoords$x,each=length(invariable$xyCoords$y)),
                                                             Latitude=rep(invariable$xyCoords$y,length(invariable$xyCoords$x)),
                                                             Invarible=as.numeric(redim(invariable,drop=T)$Data))#Annual

#Annual
season <- "Annual"
indices <- c("wsdi","csdi","tr",
             "r20mm","prcptot","cdd","cwd")

for(sc in 1:3){
  load(paste("map.nomask.indices.yr.CMIP6.",scenario[sc],".Rdata",sep="")) 
  
  test <- list()
  for(i in 1:length(indices)){
    test[[i]] <- list()
    for(m in 1:length(series.indices[[i]])){
      test[[i]][[m]] <- do.call("rbind",series.indices[[i]][[m]])
    }
  }
  
  test2 <- list()
  for(i in 1:length(indices)){
    test2[[i]] <- do.call("rbind",test[[i]])
  }
  
  test3 <- do.call("rbind",test2)
  
  Model <- unique(test3$Model)
  Model <- Model[order(Model)]
  
  test3$Model <- factor(test3$Model,levels=rev(Model))
  test3$Index <- toupper(test3$Index)
  test3$Index <- factor(test3$Index,levels=toupper(c("cdd","cwd","prcptot","r20mm","csdi","wsdi","tr")))
  
  #Remuevo TaiESM1
  if("TaiESM1"%in%test3$Model){
  test3 <- test3[-which(test3$Model=="TaiESM1"),]}
  
  ensemble <- aggregate(Value~Latitude+Longitude+Index,test3,FUN = "mean",na.rm=T)
  ensemble.sd <- aggregate(Value~Latitude+Longitude+Index,test3,FUN = "sd",na.rm=T)
  
  ensemble$ratio <- ensemble$Value/ensemble.sd$Value
  invariable.rep <- do.call("rbind", replicate(length(indices), invariable.data, simplify = FALSE))
  ensemble$ratio[which(is.na(invariable.rep$Invarible))] <- NaN
    
  indices.pr <- toupper(c("cdd","cwd","r20mm","prcptot"))
  indices.temp <- toupper(c("csdi","wsdi","tr"))
  for(m in 1:length(indices.pr)){
    Map <- subset(ensemble,Index%in%toupper(c(indices.pr[m])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  +
      scale_fill_gradientn(name="Change",colours=brewer.pal(11,"BrBG"),
                           limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(min(ensemble$Longitude),max(ensemble$Longitude)),
                     ylim=c(min(ensemble$Latitude),max(ensemble$Latitude)),expand=F)+ borders(colour = "black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_EuroMediterranean_Annual_",indices.pr[m],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=4000,height=2000)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off() 
    
    gc()
    
    Map <- subset(ensemble,Index%in%toupper(c(indices.pr[m])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  +
      scale_fill_gradientn(name="Change",colours=brewer.pal(11,"BrBG"),limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(0,4),
                     ylim=c(40,43),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_Catalonia_Annual_",indices.pr[m],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=4000,height=2000)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off()
    
    rm(p) ; gc()
  }
  
  for(n in 1:length(indices.temp)){
    Map <- subset(ensemble,Index%in%toupper(c(indices.temp[n])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  + 
      scale_fill_gradientn(name="Change",colours=brewer.pal(11,"RdBu"),
                           limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(min(ensemble$Longitude),max(ensemble$Longitude)),
                     ylim=c(min(ensemble$Latitude),max(ensemble$Latitude)),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_EuroMediterranean_Annual_",indices.temp[n],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=3000,height=1500)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off() 
    
    gc() ; rm(p)
    
    Map <- subset(ensemble,Index%in%toupper(c(indices.temp[n])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  + 
      scale_fill_gradientn(name="Change",colours=brewer.pal(11,"RdBu"),limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(0,4),
                     ylim=c(40,43),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_Catalonia_Annual_",indices.temp[n],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=3000,height=1500)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off() 
    
    rm(p) ; gc()
  }
  
}

#-------------------------------------------------#
rm(test,test2,test3,series.indices) ; gc()

#Monthly
season <- "Seasonal"
indices <- c("txx","txn","tnx","tnn","tx90p","tx10p","tn90p","tn10p",
             "rx5day","rx1day")
indices.pr <- c("rx5day","rx1day")
indices.temp <- c("txx","txn","tnx","tnn","tx90p","tx10p","tn90p","tn10p")

for(sc in 1:3){
  load(paste("map.nomask.indices.mon.CMIP6.",scenario[sc],".Rdata",sep="")) 
  
  test <- list()
  for(i in 1:length(indices)){
    test[[i]] <- list()
    for(m in 1:length(series.indices[[i]])){
      test[[i]][[m]] <- do.call("rbind",series.indices[[i]][[m]])
    }
  }
  
  test2 <- list()
  for(i in 1:length(indices)){
    test2[[i]] <- do.call("rbind",test[[i]])
  }
  
  test3 <- do.call("rbind",test2)
  
  Model <- unique(test3$Model)
  Model <- Model[order(Model)]
  
  test3$Model <- factor(test3$Model,levels=rev(Model))
  test3$Index <- toupper(test3$Index)
  test3$Index <- factor(test3$Index,levels=toupper(indices))
  
  #Remuevo TaiESM1
  if("TaiESM1"%in%test3$Model){
    test3 <- test3[-which(test3$Model=="TaiESM1"),]}
  
  ensemble <- aggregate(Value~Latitude+Longitude+Index+Season,test3,FUN = "mean",na.rm=T)
  ensemble.sd <- aggregate(Value~Latitude+Longitude+Index+Season,test3,FUN = "sd",na.rm=T)
  
  ensemble$ratio <- ensemble$Value/ensemble.sd$Value
  invariable.rep <- do.call("rbind", replicate(length(indices)*4, invariable.data, simplify = FALSE))
  ensemble$ratio[which(is.na(invariable.rep$Invarible))] <- NaN
  
  ensemble$Season <- factor(ensemble$Season,levels=c("Summer","Autumn","Winter","Spring"))
  
  rm(test,test2,test3,series.indices) ; gc()
  
  for(m in 1:length(indices.pr)){
    Map <- subset(ensemble,Index%in%toupper(c(indices.pr[m])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  +facet_wrap(~Season)+
      scale_fill_gradientn(name="Change",colours=brewer.pal(11,"BrBG"),
                           limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(min(ensemble$Longitude),max(ensemble$Longitude)),
                     ylim=c(min(ensemble$Latitude),max(ensemble$Latitude)),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_EuroMediterranean_Seasonal_",indices.pr[m],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),
        res=300,width=4000,height=2000)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off() 
    
    gc()
    
    Map <- subset(ensemble,Index%in%toupper(c(indices.pr[m])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  +facet_wrap(~Season)+
      scale_fill_gradientn(name="Change",colours=brewer.pal(11,"BrBG"),limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(0,4),
                     ylim=c(40,43),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.pr[m]))),
                        aes(label="*",fontface="bold"),size=7)}
    
    png(filename = paste(OUTPUTS,"DeltaChange_Catalonia_Seasonal_",indices.pr[m],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=4000,height=2000)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off()
  }
  
  rm(test,test2,test3,series.indices) ; gc()
  
  for(n in 1:length(indices.temp)){
    Map <- subset(ensemble,Index%in%toupper(c(indices.temp[n])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  + facet_wrap(~Season)+
      scale_fill_gradientn(name="Change",colours=rev(brewer.pal(11,"RdBu")),
                           limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(min(ensemble$Longitude),max(ensemble$Longitude)),
                     ylim=c(min(ensemble$Latitude),max(ensemble$Latitude)),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_EuroMediterranean_Seasonal_",indices.temp[n],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=3000,height=1500)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off() 
    
    gc() ; rm(p)
    
    Map <- subset(ensemble,Index%in%toupper(c(indices.temp[n])))
    p <- ggplot(data=Map,aes(x=Longitude,y=Latitude,z=Value)) + 
      geom_contour_fill(bins=20)  + facet_wrap(~Season)+
      scale_fill_gradientn(name="Change",colours=rev(brewer.pal(11,"RdBu")),limits=c(-max(abs(range(Map$Value,na.rm=T))),max(abs(range(Map$Value,na.rm=T)))),
                           na.value = "white")+
      coord_quickmap(xlim=c(0,4),
                     ylim=c(40,43),expand=F)+ borders(colour="black") + 
      theme_bw() + ggtitle(paste(season,unique(Map$Index),scenario[sc],sep=" "))
    
    if(dim(subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))))[1]!=0){
      p <- p +geom_text(data=subset(ensemble,ratio>1 & Index%in%toupper(c(indices.temp[n]))),
                        aes(label="*",fontface="bold"),size=7)#+geom_text(aes(label="*",fontface="bold",lty))
    }
    
    png(filename = paste(OUTPUTS,"DeltaChange_Catalonia_Seasonal_",indices.temp[n],"_",scenario[sc],"_CMIP6_Change_2070-2100_Map",".png",sep=""),res=300,width=3000,height=1500)
    print(p)#grid.arrange(p,h,g,i,nrow=2))
    dev.off() 
  }
  
}
